osg::Shader Class Reference

`#include <Shader>`

Inheritance diagram for osg::Shader:

## Classes

class | PerContextShader
struct | ShaderObjects

## Public Types

enum | Type { VERTEX = GL_VERTEX_SHADER , TESSCONTROL = GL_TESS_CONTROL_SHADER , TESSEVALUATION = GL_TESS_EVALUATION_SHADER , GEOMETRY = GL_GEOMETRY_SHADER , FRAGMENT = GL_FRAGMENT_SHADER , COMPUTE = GL_COMPUTE_SHADER , UNDEFINED = -1 }
enum | ShaderDefinesMode { USE_SHADER_PRAGMA , USE_MANUAL_SETTINGS }
typedef std::multimap< float, std::string > | CodeInjectionMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Shader (Type type=UNDEFINED)
| Shader (Type type, const std::string &source)
| Shader (Type type, ShaderBinary *shaderBinary)
| Shader (const Shader &rhs, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, Shader)
int | compare (const Shader &rhs) const
bool | setType (Type t)
Type | getType () const
const char * | getTypename () const
void | setFileName (const std::string &fileName)
const std::string & | getFileName () const
void | setShaderSource (const std::string &sourceText)
const std::string & | getShaderSource () const
void | setShaderDefinesMode (ShaderDefinesMode sdm)
ShaderDefinesMode | getShaderDefinesMode () const
void | setShaderDefines (const ShaderDefines &shaderDefs)
ShaderDefines & | getShaderDefines ()
const ShaderDefines & | getShaderDefines () const
void | setShaderRequirements (const ShaderDefines &shaderDefs)
ShaderDefines & | getShaderRequirements ()
const ShaderDefines & | getShaderRequirements () const
void | setShaderBinary (ShaderBinary *shaderBinary)
ShaderBinary * | getShaderBinary ()
const ShaderBinary * | getShaderBinary () const
void | addCodeInjection (float position, const std::string &code)
CodeInjectionMap & | getCodeInjectionMap ()
const CodeInjectionMap & | getCodeInjectionMap () const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
void | releaseGLObjects (osg::State *state=0) const
void | dirtyShader ()
void | compileShader (osg::State &state) const
PerContextShader * | getPCS (osg::State &state) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static Shader::Type | getTypeId (const std::string &tname)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef std::set< osg::Program * > | ProgramSet

## Protected Member Functions

virtual | ~Shader ()
bool | addProgramRef (osg::Program *program)
bool | removeProgramRef (osg::Program *program)
void | _computeShaderDefines ()
void | _parseShaderDefines (const std::string &str, ShaderDefines &defines)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Type | _type
std::string | _shaderFileName
std::string | _shaderSource
osg::ref_ptr< ShaderBinary > | _shaderBinary
CodeInjectionMap | _codeInjectionMap
ShaderDefinesMode | _shaderDefinesMode
ShaderDefines | _shaderDefines
ShaderDefines | _shaderRequirements
ProgramSet | _programSet
OpenThreads::Mutex | _programSetMutex
osg::buffered_value< osg::ref_ptr< ShaderObjects > > | _pcsList
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Friends

class | osg::Program

## Detailed Description

osg::Shader is an application-level abstraction of an OpenGL glShader. It is a container to load the shader source code text and manage its compilation. An osg::Shader may be attached to more than one osg::Program. Shader will automatically manage per-context instancing of the internal objects, if that is necessary for a particular display configuration.

## Member Typedef Documentation

## CodeInjectionMap

typedef std::multimap<float, std::string> osg::Shader::CodeInjectionMap

The code injection map used when generating the main shader during main shader composition.

## ProgramSet

typedef std::set< osg::Program* > osg::Shader::ProgramSet

protected

osg::Programs that this osg::Shader is attached to

## Member Enumeration Documentation

## ShaderDefinesMode

enum osg::Shader::ShaderDefinesMode

Enumerator
USE_SHADER_PRAGMA |
USE_MANUAL_SETTINGS |

## Type

enum osg::Shader::Type

Enumerator
VERTEX |
TESSCONTROL |
TESSEVALUATION |
GEOMETRY |
FRAGMENT |
COMPUTE |
UNDEFINED |

## Constructor & Destructor Documentation

## Shader() [1/4]

osg::Shader::Shader | ( | Type | type = UNDEFINED | ) |

References UNDEFINED.

Referenced by compare(), META_Object(), osg::Shader::PerContextShader::PerContextShader(), Shader(), and osg::Shader::ShaderObjects::ShaderObjects().

## Shader() [2/4]

osg::Shader::Shader | ( | Type | type,
|  | const std::string & | source )

## Shader() [3/4]

osg::Shader::Shader | ( | Type | type,
|  | ShaderBinary * | shaderBinary )

## Shader() [4/4]

osg::Shader::Shader | ( | const Shader & | rhs,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Shader(), and osg::CopyOp::SHALLOW_COPY.

## ~Shader()

virtual osg::Shader::~Shader | ( |  | ) |

protected virtual

## Member Function Documentation

## _computeShaderDefines()

void osg::Shader::_computeShaderDefines | ( |  | ) |

protected

## _parseShaderDefines()

void osg::Shader::_parseShaderDefines | ( | const std::string & | str,
|  | ShaderDefines & | defines )

protected

## addCodeInjection()

void osg::Shader::addCodeInjection | ( | float | position,
|  | const std::string & | code )

inline

Add code injection that will be placed in the main shader to enable support for this shader. The position is set up so that code to be inserted before the main() will have a negative value, a position between 0 and 1.0 will be inserted in main() and a position greater than 1.0 will be placed after the main(). During shader composition all the code injections are sorted in ascending order and then placed in the appropriate section of the main shader.

References _codeInjectionMap.

## addProgramRef()

bool osg::Shader::addProgramRef | ( | osg::Program * | program | ) |

protected

## compare()

int osg::Shader::compare | ( | const Shader & | rhs | ) | const

References Shader().

## compileShader()

void osg::Shader::compileShader | ( | osg::State & | state | ) | const

If needed, compile the PCS's glShader

## dirtyShader()

void osg::Shader::dirtyShader | ( |  | ) |

Mark our PCSs as needing recompilation. Also mark Programs that depend on us as needing relink

## getCodeInjectionMap() [1/2]

CodeInjectionMap & osg::Shader::getCodeInjectionMap | ( |  | ) |

inline

Get the code injection map.

References _codeInjectionMap.

## getCodeInjectionMap() [2/2]

const CodeInjectionMap & osg::Shader::getCodeInjectionMap | ( |  | ) | const

inline

Get the const code injection map.

References _codeInjectionMap.

## getFileName()

const std::string & osg::Shader::getFileName | ( |  | ) | const

inline

Get filename to which the shader source code belongs.

References _shaderFileName.

## getPCS()

PerContextShader * osg::Shader::getPCS | ( | osg::State & | state | ) | const

## getShaderBinary() [1/2]

ShaderBinary * osg::Shader::getShaderBinary | ( |  | ) |

inline

Get the Shader's ShaderBinary, return NULL if none is assigned.

References _shaderBinary.

## getShaderBinary() [2/2]

const ShaderBinary * osg::Shader::getShaderBinary | ( |  | ) | const

inline

Get the const Shader's ShaderBinary, return NULL if none is assigned.

References _shaderBinary.

## getShaderDefines() [1/2]

ShaderDefines & osg::Shader::getShaderDefines | ( |  | ) |

inline

References _shaderDefines.

## getShaderDefines() [2/2]

const ShaderDefines & osg::Shader::getShaderDefines | ( |  | ) | const

inline

References _shaderDefines.

## getShaderDefinesMode()

ShaderDefinesMode osg::Shader::getShaderDefinesMode | ( |  | ) | const

inline

References _shaderDefinesMode.

## getShaderRequirements() [1/2]

ShaderDefines & osg::Shader::getShaderRequirements | ( |  | ) |

inline

References _shaderRequirements.

## getShaderRequirements() [2/2]

const ShaderDefines & osg::Shader::getShaderRequirements | ( |  | ) | const

inline

References _shaderRequirements.

## getShaderSource()

const std::string & osg::Shader::getShaderSource | ( |  | ) | const

inline

Query the shader's source code text

References _shaderSource.

## getType()

Type osg::Shader::getType | ( |  | ) | const

inline

Get the Shader type as an enum.

References _type.

## getTypeId()

Shader::Type osg::Shader::getTypeId | ( | const std::string & | tname | ) |

static

## getTypename()

const char * osg::Shader::getTypename | ( |  | ) | const

Get the Shader type as a descriptive string.

## META_Object()

osg::Shader::META_Object | ( | osg | ,
|  | Shader | )

References Shader().

## releaseGLObjects()

void osg::Shader::releaseGLObjects | ( | osg::State * | state = 0 | ) | const

virtual

release OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objects for all graphics context if State object pointer NULL.

Reimplemented from osg::Object.

## removeProgramRef()

bool osg::Shader::removeProgramRef | ( | osg::Program * | program | ) |

protected

## resizeGLObjectBuffers()

virtual void osg::Shader::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Object.

## setFileName()

void osg::Shader::setFileName | ( | const std::string & | fileName | ) |

inline

Set file name for the shader source code.

References _shaderFileName.

## setShaderBinary()

void osg::Shader::setShaderBinary | ( | ShaderBinary * | shaderBinary | ) |

inline

Set the Shader using a ShaderBinary.

References _shaderBinary.

## setShaderDefines()

void osg::Shader::setShaderDefines | ( | const ShaderDefines & | shaderDefs | ) |

inline

References _shaderDefines.

## setShaderDefinesMode()

void osg::Shader::setShaderDefinesMode | ( | ShaderDefinesMode | sdm | ) |

inline

References _shaderDefinesMode.

## setShaderRequirements()

void osg::Shader::setShaderRequirements | ( | const ShaderDefines & | shaderDefs | ) |

inline

References _shaderRequirements.

## setShaderSource()

void osg::Shader::setShaderSource | ( | const std::string & | sourceText | ) |

Set the Shader's source code text from a string.

## setType()

bool osg::Shader::setType | ( | Type | t | ) |

Set the Shader type as an enum.

## Friends And Related Symbol Documentation

## osg::Program

friend class osg::Program

friend

## Member Data Documentation

## _codeInjectionMap

CodeInjectionMap osg::Shader::_codeInjectionMap

protected

Referenced by addCodeInjection(), getCodeInjectionMap(), and getCodeInjectionMap().

## _pcsList

osg::buffered_value< osg::ref_ptr<ShaderObjects> > osg::Shader::_pcsList

mutable protected

## _programSet

ProgramSet osg::Shader::_programSet

protected

## _programSetMutex

OpenThreads::Mutex osg::Shader::_programSetMutex

protected

## _shaderBinary

osg::ref_ptr<ShaderBinary> osg::Shader::_shaderBinary

protected

Referenced by getShaderBinary(), getShaderBinary(), and setShaderBinary().

## _shaderDefines

ShaderDefines osg::Shader::_shaderDefines

protected

Referenced by getShaderDefines(), getShaderDefines(), and setShaderDefines().

## _shaderDefinesMode

ShaderDefinesMode osg::Shader::_shaderDefinesMode

protected

Referenced by getShaderDefinesMode(), and setShaderDefinesMode().

## _shaderFileName

std::string osg::Shader::_shaderFileName

protected

Referenced by getFileName(), and setFileName().

## _shaderRequirements

ShaderDefines osg::Shader::_shaderRequirements

protected

Referenced by getShaderRequirements(), getShaderRequirements(), and setShaderRequirements().

## _shaderSource

std::string osg::Shader::_shaderSource

protected

Referenced by getShaderSource().

## _type

Type osg::Shader::_type

protected

Referenced by getType().

The documentation for this class was generated from the following file:

- Shader